﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        // Toto jsou nanicovaté metody, jimž dal vzniknout jen omyl :-))
        // musí tu ale být, protože byly už v jádře deklarovány a já nerad lezu do jádra
        private void label1_Click(object sender, EventArgs e)
        {
            // Nedělat nic
        }

        private void Obraz_TextChanged(object sender, EventArgs e)
        {
        }

        private void Adresar_TextChanged_1(object sender, EventArgs e)
        {

        }

        // Funkční funkcionální jádro

        // Po každé změně horního vstupního políčka se musí aktualizovat seznam souborů
        private void Adresar_TextChanged(object sender, EventArgs e)
        {
            // Definuji adresářové informace, 
            DirectoryInfo AdrInformace = new DirectoryInfo(Adresar.Text);
            // do pole řetězců vyextrahuji soubory s příponou .jpg, 
            string[] VseckyJPEGSoubory = (AdrInformace.GetFiles("*.jpg")).ToArray<string>;
            // a zobrazím seznam v textovém poli :-)
            SouboryTextPole.Lines = VseckyJPEGSoubory;
            
        }

        
        // Pokaždé, když se změní dolní vstupní políčko, zobrazí se dotyčný obrázek
        private void JPEGObraz_TextChanged(object sender, EventArgs e)
        {
            // dojde ke změně obrázku
            ObrazovaPlocha.ImageLocation = ZvolenyJPEG.Text;
            // a ke změně informací
            FileInfo SouborInfo = new FileInfo(JPEGObraz.Text);
            JPEGByteSize.Value = SouborInfo.Length;
        }


        private void Form1_Load(object sender, EventArgs e)
        {
           
        }

        // Vygeneruje HTML fotoalbum
        private void GenerovatHTMLFoto_Click(object sender, EventArgs e)
        {
            // Nahrát objekt a extrahovat JPEG soubory
            DirectoryInfo AdrInfo = new DirectoryInfo(Adresar.Text);
            string[] SeznamSouboru = AdrInfo.GetFiles("*.jpg");
            // A generujeme:
            StreamWriter PsaciProud=new StreamWriter("fotoalbum.html");
            // nejdřív hlavu, 
            PsaciProud.WriteLine("<html");
            PsaciProud.WriteLine("<head><title>Fotoalbum</title></head>");
            PsaciProud.WriteLine("<body>");
            foreach (string Foto in SeznamSouboru)
            {
                // pak jednotlivé obrázky
                PsaciProud.WriteLine("Fotka "+Foto);
                PsaciProud.WriteLine("<img src=\"" + Foto + "\"><br>");
            }
            // a potom konec
            PsaciProud.WriteLine("</body>");
            PsaciProud.WriteLine("</html");
         }

        private void PromitatScreensaver_Click(object sender, EventArgs e)
        {
            // Nahrát objekt a extrahovat JPEG soubory
            DirectoryInfo AdrInfo = new DirectoryInfo(Adresar.Text);
            string[] SeznamSouboru = AdrInfo.GetFiles("*.jpg");
            // Zvětšíme na maximum

            // Přesuneme do levého horního rožku
            ObrazovaPlocha.Location.X = 0;
            ObrazovaPlocha.Location.Y = 0;
            // Zvětšíme přes celou obrazovku
            ObrazovaPlocha.Size.Width = 1024;
            ObrazovaPlocha.Size.Height = 768;
       
            // Nastartujeme intervalátor
            UrcovacIntervalu.Start();
       }

        // Zobrazí obrázek přes celou obrazovku (kliknutím se to zruší)
        private void ZobrazitNaCelouObrazovku_Click(object sender, EventArgs e)
        {
            // Přesuneme do levého horního rožku
            ObrazovaPlocha.Location.X = 0;
            ObrazovaPlocha.Location.Y = 0;
            // Zvětšíme přes celou obrazovku
            ObrazovaPlocha.Size.Width = 1024;
            ObrazovaPlocha.Size.Height = 768;
        }

        // Trochu zvětší obrázek
        private void TrochuZvetsit_Click(object sender, EventArgs e)
        {
            // Rozšířit a zvýšit obrázek o 5 px
            ObrazovaPlocha.Size.Width = ObrazovaPlocha.Size.Width + 5;
            ObrazovaPlocha.Size.Height = ObrazovaPlocha.Size.Height + 5;
        }

        // Trochu zmenší obrázek
        private void TrochuZmensit_Click(object sender, EventArgs e)
        {
            // Smrsknout a snížit obrázek o 5 px
            ObrazovaPlocha.Size.Width = ObrazovaPlocha.Size.Width - 5;
            ObrazovaPlocha.Size.Height = ObrazovaPlocha.Size.Height - 5;
        }

        // Umístí obrázek na defaultní posici
        private void Defaultne_Click(object sender, EventArgs e)
        {
            ObrazovaPlocha.Location.X = 551;
            ObrazovaPlocha.Location.Y = 61;
            ObrazovaPlocha.Size.Width = 439;
            ObrazovaPlocha.Size.Height = 607;
        }

        // Ukáže první soubor v abecedě
        private void Prvni_Click(object sender, EventArgs e)
        {
            // Nahraju objekt adresářové informace
            DirectoryInfo AdrInfo = new DirectoryInfo(Adresar.Text);
            // Extrahuji seznam JPEG souborů
            string[] SeznamSouboru = AdrInfo.GetFiles("*.jpg");
            // Zobrazím první v abecedě
            ObrazovaPlocha.ImageLocation = SeznamSouboru[0];
            // Zobrazím jméno souboru v poli pro soubor
            JPEGObraz.Text = SeznamSouboru[0];
            // Zobrazím index a bytesize
            Indx.Value = 0;
            FileInfo SouborInfo = new FileInfo(JPEGObraz.Text);
            JPEGByteSize.Value = SouborInfo.Length;
        }

        // Ukáže předchozí soubor
        private void Predchozi_Click(object sender, EventArgs e)
        {
            // Zase adr. informace
            DirectoryInfo AdrInfo = new DirectoryInfo(Adresar.Text);
            // a zase seznam souborů
            string[] SeznamSouboru = AdrInfo.GetFiles("*.jpg");
            // Zjistím, jaký index má tento obrázek
            for (int i = 0; i <= --SeznamSouboru.Length; i++)
            {
                // Pokud se index rovná cestě k obrazu
                if (String.Compare(SeznamSouboru[i], ObrazovaPlocha.ImageLocation))
                {
                    // zruším vše a v proměnné i mi zůstane index
                    break;
                }
            }
            // Od indexu odečtu jedničku a použiju jej
            ObrazovaPlocha.ImageLocation = SeznamSouboru[--i];
            JPEGObraz.Text = ObrazovaPlocha.ImageLocation;
            // Zobrazím index a bytesize
            Indx.Value = SeznamSouboru[--i];
            FileInfo SouborInfo = new FileInfo(JPEGObraz.Text);
            JPEGByteSize.Value = SouborInfo.Length;
       
            
        }

        // Ukáže další soubor
        private void Dalsi_Click(object sender, EventArgs e)
        {
            // Zase adr. informace
            DirectoryInfo AdrInfo = new DirectoryInfo(Adresar.Text);
            // a zase seznam souborů
            string[] SeznamSouboru = AdrInfo.GetFiles("*.jpg");
            // Zjistím, jaký index má tento obrázek
            for (int i = 0; i <= --SeznamSouboru.Length; i++)
            {
                // Pokud se index rovná cestě k obrazu
                if (String.Compare(SeznamSouboru[i], ObrazovaPlocha.ImageLocation))
                {
                    // zruším vše a v proměnné i mi zůstane index
                    break;
                }
            }
            // K indexu přičtu jedničku a použiju jej
            ObrazovaPlocha.ImageLocation = SeznamSouboru[++i];
            JPEGObraz.Text = ObrazovaPlocha.ImageLocation;
            // Zobrazím index a bytesize
            Indx.Value = 0;
            FileInfo SouborInfo = new FileInfo(Adresar.Text);
            JPEGByteSize.Value = SouborInfo.Length;
        
            
        }

        // Ukáže poslední soubor
        private void Posledni_Click(object sender, EventArgs e)
        {
            // Nahraju objekt adresářové informace
            DirectoryInfo AdrInfo = new DirectoryInfo(Adresar.Text);
            // Extrahuji seznam JPEG souborů
            string[] SeznamSouboru = AdrInfo.GetFiles("*.jpg");
            // Zobrazím první v abecedě
            ObrazovaPlocha.ImageLocation = SeznamSouboru[0];
            // Zobrazím jméno souboru v poli pro soubor
            JPEGObraz.Text = SeznamSouboru[--SeznamSouboru.Length];
            // Zobrazím index a bytesize
            Indx.Value = 0;
            FileInfo SouborInfo = new FileInfo(Adresar.Text);
            JPEGByteSize.Value = SouborInfo.Length;
        }
        
        // Umístí obrázek na defaultní posice
        private void ObrazovaPlocha_Click(object sender, EventArgs e)
        {
            ObrazovaPlocha.Location.X = 551;
            ObrazovaPlocha.Location.Y = 61;
            ObrazovaPlocha.Size.Width = 439;
            ObrazovaPlocha.Size.Height = 607;
        }

        private void UrcovacIntervalu_Tick(object sender, EventArgs e)
        {
            DirectoryInfo AdrInf = new DirectoryInfo(Adresar.Text);
            string[] SeznamSouboru = AdrInf.GetFiles("*.jpg");
            // Zjistím index momentálního obrázku
            for (int i = 0; i <= --SeznamSouboru.Length; i++)
            {
                // Pokud se index rovná cestě k obrazu
                if (String.Compare(SeznamSouboru[i], ObrazovaPlocha.ImageLocation))
                {
                    // zruším vše a v proměnné i mi zůstane index
                    break;
                }
            }
            // A přehodím jej na další
            ObrazovaPlocha.ImageLocation = SeznamSouboru[++i];
            Adresar.Text = SeznamSouboru[++i];

        }

        private void BylaZmcknutaKlavesa(object sender, KeyPressEventArgs e)
        {

        }
    }
}
